package com.agileworks.machine;

public class Controller {

    private Panel panel;
    private Cashier cashier;
    private CoffeeType type;
    private Dispenser dispenser;

    public Controller(final Panel panel, final Cashier cashier, final Dispenser dispenser) {
        this.panel = panel;
        this.cashier = cashier;
        this.dispenser = dispenser;
        refresh();
        panel.display("Please select a coffee type");
    }

    private void refresh() {
        panel.display("Getting Ready...");
        panel.unavailable(dispenser.unavailableCoffeTypes());
    }

    public void selectedCoffee(final CoffeeType type) {
        this.type = type;
        String price = cashier.priceFor(type);
        panel.display("Please insert " + price);
    }

    public void accept(final AmericanCoins coins) {
        String change = cashier.returnChangeFor(type, coins);
        String changeDescriptionInMsg = ".0$".equals(change) ? " " : " your change of " + change + " and ";
        panel.display("Please collect" + changeDescriptionInMsg + "your delicious coffee");
        dispenser.serve(type);
        refresh();
    }

}
